<?php

function xdirname($s)
{
	$r = dirname($s);
	if(basename($r) == "scripts")
	{
		$r = substr($r, 0, strlen($r)-strlen('/scripts'));
	}
	if($r=='/') return '';
	return $r;
}

include('config.inc');
error_reporting(E_ALL);
function einclude($path) { 
	include($GLOBALS['MYDIR'] . '/' . $path); 
}

$FILES = array( 'php/objects/events.inc' , 'php/objects/event.inc', 
		'php/pages.inc',
		);
foreach ($FILES as $file) { einclude($file); }

function event_path($event = '')
	{
		$pre = $GLOBALS['EVENT_PREFIX'];
		if(!$event && isset($GLOBALS['PAGE']['event']))
		{
			$event = $GLOBALS['PAGE']['event'];
		}
		if($event)
		{
			return $pre . $event->getName();
		}
		return '';
	}

function event_head() { einclude('php/head.inc'); }
function event_tail() { einclude('php/tail.inc'); }
function event_script() 
	{ 
		print "<p><a href='".event_path()."'>" . event_text("ReturnToEventP") ."</a></p>\n";
	}

function event_page($page) { 
	$template = 'default';
	event_template($template, 'HEAD', $page);
	event_template($template, 'PAGE', $page);
	event_template($template, 'FOOT', $page);
}

function event_pagec($page) {
	$event = $GLOBALS['PAGE']['event'];
	$pagec = file_get_contents($GLOBALS['PAGE_DIR'] . $page); 
	$output = _event_pagec_parseloops($event, $pagec);
	print $output;
}

function _event_pagec_parseloops($event, $page, $objects=array())
{
	$len = strlen($page);
	$i=0; $j=-1; $last_output=0;
	$output = "";
	$tokLen=strlen('@*');
	while($i < $len)
	{
		$i=strpos($page, ($j<0?'@*':'*@'), $i);
		if($i !== false)
		{
			if($j < 0)
			{
				$j=$i++;
			} 
			else
			{
				if($j != $last_output)
				{
					$data = substr($page, $last_output, $j-$last_output);
					$output .= _event_pagec($event, $data, $objects);
				}
				$string = substr($page, $j+$tokLen, $i-$j-$tokLen); $j=-1;
				$values = split("#", $string, 3);
				if(sizeof($values)==3)
				{
					$myValues = $event->getEValue($values[1]);
					if(!is_array($myValues))
					{
						$myValues = array($myValues);
					}
					foreach($myValues as $v)
					{
						$objects[$values[0]] = $v;
						$value  = _event_pagec($event, $values[2], $objects);
						$output .= $value;
					}
				}
				$i+=$tokLen;
				$last_output = $i;
			}
		}
		else
		{
			if($last_output < $len) 
			{
				$data = substr($page, $last_output, $len-$last_output);
				$output .= _event_pagec($event, $data);
			}
			$i=$len;
		}
	}
	return $output;
}

function _event_pagec_getValue($objects, $key)
{
	$value = null;
	if($value = $objects[$key])
	{
		return $value;
	}
	list($newKey, $restKey) = split("\.", $key, 2);
	if($value = $objects[$newKey])
	{
		return _event_pagec_getValue($value, $restKey);
	}
	return null;
}

#
# Renders a page without loops
#
function _event_pagec($event, $page, $objects=array())
{
	$len = strlen($page);
	$i=0; $j=-1; $last_output=0;
	$output = "";
	while($i < $len)
	{
		$i=strpos($page, '@', $i);
		if($i !== false)
		{
			if($j < 0)
			{
				$j=$i++;
			} 
			else
			{
				if($j != $last_output)
				{
					$output .= substr($page, $last_output, $j-$last_output);
				}
				$string = substr($page, $j+1, $i-$j-1); $j=-1;
				$values = split("#", $string);
				$key = array_shift($values);
				$value = $key?event_text($key):"{0}";
				for($x=0; $x < sizeof($values); ++$x)
				{
					if($values[$x]=="") next;
					if(!($myValue  = _event_pagec_getValue($objects, $values[$x])))
					{
						$myValue = $event->getEValue($values[$x]);
					}
					$value = str_replace('{' . $x . '}', $myValue, $value);
				}
				$output .= $value;
				$last_output = ++$i;
			}
		}
		else
		{
			if($last_output < $len) $output .= substr($page, $last_output, $len-$last_output);
			$i=$len;
		}
	}
	return $output;
}

function event_template($template, $part, $page) { 
	include($GLOBALS['MYDIR'] . '/template/' . $template . '/' . $part. '.inc'); 
}

function _event_getResourceFile()
{
	if(!isset($GLOBALS['RESOURCE_FILE']))
	{
		$GLOBALS['RESOURCE_FILE'] = file($GLOBALS['RESOURCE_DIR'] .'/'. $GLOBALS['RESOURCE_DEFAULT']);
	}
	return $GLOBALS['RESOURCE_FILE'];
}

function event_text($key, $values=array())
{
	$resources = _event_getResourceFile();
	foreach($resources as $r)
	{
		list($k, $v) = split('=', $r, 2);
		if($k == $key)
		{
			return $v;
		}
	}
}

?>
